VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "Comdlg32.ocx"
Begin VB.MDIForm frmMain 
   AutoShowChildren=   0   'False
   BackColor       =   &H8000000C&
   Caption         =   "Acq"
   ClientHeight    =   4275
   ClientLeft      =   165
   ClientTop       =   855
   ClientWidth     =   7395
   LinkTopic       =   "MDIForm1"
   StartUpPosition =   3  'Windows Default
   Begin MSComDlg.CommonDialog cd 
      Left            =   840
      Top             =   1320
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Menu fic 
      Caption         =   "&Fichier"
      Begin VB.Menu ficopen 
         Caption         =   "&Ouvrir"
         Shortcut        =   ^O
      End
      Begin VB.Menu ficsave 
         Caption         =   "&Enregistrer"
         Shortcut        =   ^S
      End
      Begin VB.Menu ficsaveas 
         Caption         =   "&Enregistrer sous..."
      End
      Begin VB.Menu tir545121 
         Caption         =   "-"
      End
      Begin VB.Menu ficquit 
         Caption         =   "&Quitter"
      End
   End
   Begin VB.Menu edi 
      Caption         =   "&Edition"
      Begin VB.Menu edicop 
         Caption         =   "&Copier"
         Shortcut        =   ^C
      End
      Begin VB.Menu edicol 
         Caption         =   "Co&ller"
         Shortcut        =   ^V
      End
      Begin VB.Menu Tir654213213 
         Caption         =   "-"
      End
      Begin VB.Menu edipivd 
         Caption         =   "Pivoter vers la &droite"
      End
      Begin VB.Menu edipivg 
         Caption         =   "Pivoter vers la &gauche"
      End
      Begin VB.Menu tir654654645 
         Caption         =   "-"
      End
      Begin VB.Menu editext 
         Caption         =   "Insrer un texte"
      End
   End
   Begin VB.Menu acq 
      Caption         =   "&Acqurir"
      Begin VB.Menu acqSelect 
         Caption         =   "Choisir la &source"
      End
      Begin VB.Menu acqGo 
         Caption         =   "&Acqurir (UI)"
      End
      Begin VB.Menu acqacq 
         Caption         =   "A&cqurir"
         Begin VB.Menu acq1b75d 
            Caption         =   "1 bit - 75 dpi"
         End
         Begin VB.Menu acq1b300d 
            Caption         =   "1 bit - 300 dpi"
         End
         Begin VB.Menu tir5423123 
            Caption         =   "-"
         End
         Begin VB.Menu acq8b75d 
            Caption         =   "8 bits - 75 dpi - grayscale"
         End
         Begin VB.Menu acq8b300d 
            Caption         =   "8 bits - 300 dpi - grayscale"
         End
         Begin VB.Menu tir6543212 
            Caption         =   "-"
         End
         Begin VB.Menu acq24b75d 
            Caption         =   "24 bits - 75 dpi"
         End
         Begin VB.Menu acq24b300d 
            Caption         =   "24 bits - 300 dpi"
         End
      End
      Begin VB.Menu tir521123 
         Caption         =   "-"
      End
      Begin VB.Menu acqmulti 
         Caption         =   "Acquisition &multiple"
      End
   End
   Begin VB.Menu hlp 
      Caption         =   "?"
      NegotiatePosition=   3  'Right
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Option Compare Text     ' important ici
'

Private Sub CheckNoWindows()
    ' Grise/dgrise les menus selon qu'il existe des fenetres MDI filles ou non
    
    Dim bExistChildren  As Boolean
    bExistChildren = TypeName(Me.ActiveForm) = "frmImg"
    
    ficsave.Enabled = bExistChildren
    ficsaveas.Enabled = bExistChildren
    edicop.Enabled = bExistChildren
    edipivd.Enabled = bExistChildren
    edipivg.Enabled = bExistChildren
    editext.Enabled = bExistChildren
    
End Sub


Private Sub edi_Click()
    CheckNoWindows
End Sub

Private Sub edicol_Click()
    Dim hDib        As Long
    Dim frm         As frmImg
    hDib = FTW_GetClipboard()
    
    If hDib = 0 Then
        MsgBox "Aucun DIB dans le clipboard!"
        Exit Sub
    End If
    
    Set frm = New frmImg
    
    frm.GoAcq hDib
    
End Sub

Private Sub edicop_Click()
    Dim frm     As frmImg
    Dim hDib    As Long
    
    If Not GetCurrentImgWindowAndHDIB(frm, hDib) Then Exit Sub
    
    If hDib Then
        If 0 = FTW_SetClipboard(hDib) Then
            MsgBox "Erreur lors de l'insertion de donne dans le presse-papiers"
        End If
    End If
    
    
End Sub

Private Sub edipivd_Click()
    Dim frm     As frmImg
    Dim hDib    As Long
    
    If Not GetCurrentImgWindowAndHDIB(frm, hDib) Then Exit Sub
    
    Dim hDib2       As Long
    
    hDib2 = FTW_BMP_Rotate(hDib, 1)
    If hDib2 Then
        frm.strPlus = "*"
        frm.GoAcq hDib2
    Else
        MsgBox "La rotation  echoue!"
    End If
End Sub
Private Function GetCurrentImgWindowAndHDIB(frm As frmImg, hDib As Long) As Boolean
    If GetCurrentImgWindow(frm) Then
        If frm.hMyDib <> 0 Then
            GetCurrentImgWindowAndHDIB = True
            hDib = frm.hMyDib
        End If
    End If
End Function

Private Function GetCurrentImgWindow(frm As frmImg) As Boolean
    Dim hDib        As Long
    Set frm = Me.ActiveForm
    If TypeName(frm) <> "frmImg" Then Exit Function
    GetCurrentImgWindow = True
End Function
Private Sub edipivg_Click()
    Dim frm     As frmImg
    Dim hDib    As Long
    
    If Not GetCurrentImgWindowAndHDIB(frm, hDib) Then Exit Sub
    
    Dim hDib2       As Long
    
    hDib2 = FTW_BMP_Rotate(hDib, 3)
    If hDib2 Then
        frm.strPlus = "*"
        frm.GoAcq hDib2
    Else
        MsgBox "La rotation  echoue!"
    End If
    
End Sub

Private Sub editext_Click()
    Dim frm     As frmImg
    Dim hDib    As Long
    
    If GetCurrentImgWindowAndHDIB(frm, hDib) Then
        If FTW_BMP_SetText(hDib, 50, 50, 80, 20, "Exemple" & Chr(0)) Then
            frm.strPlus = "*"
            frm.GoAcq hDib
        Else
            MsgBox "La fonction a echoue ou vous disposez d'une version non-enregistre de fayacq.dll"
        End If
    End If
    
End Sub

Private Sub fic_Click()
    CheckNoWindows
End Sub

Private Sub ficopen_Click()
    Dim hDib        As Long
    Dim rc          As Long
    
    With cd
        .Filter = "Images reconnues (*.bmp; *.jpg)|*.bmp;*.jpg"
        .Action = 1
        
        Select Case Right(.FileName, 3)
            Case "jpg"
                rc = FTW_JPG_LoadImage(hDib, .FileName & Chr(0))
                If Not rc = F_OK Then
                    MsgBox "Problme pendant l'ouverture du jpeg!"
                    Exit Sub
                End If
                
            Case "bmp"
                
                rc = FTW_BMP_LoadImage(hDib, .FileName & Chr(0))
                If Not rc = F_OK Then
                End If
                    
            Case Else
            
                MsgBox "Extention de fichier inconnue!"
                Exit Sub
                
        End Select
    
        If hDib = 0 Then
            MsgBox "Problme pendant l'ouverture du fichier!"
            Exit Sub
        End If
    
        Dim frm As New frmImg
        frm.GoAcq hDib, .FileName
        frm.strPlus = "fichier"
    
    End With
End Sub

Private Sub ficsave_Click()
    Dim frm     As frmImg
    Dim hDib    As Long
    
    If Not GetCurrentImgWindowAndHDIB(frm, hDib) Then Exit Sub
    
    If InStr(frm.strFilePath, "\") = 0 Then
        ficsaveas_Click
    Else
        frm.strPlus = ""
        Save frm.strFilePath, hDib
        frm.MajCaption
    End If
End Sub
Private Function Save(ByVal strPF As String, ByVal hDib As Long) As Boolean
    Dim rc          As Long
    
    Select Case Right(strPF, 3)
        Case "jpg"
            ' La qualit est spcifie  35 car je possde une version enregistre de FYAcq.dll ;)
            '   (la version gratuite n'accepte que des valeurs allant de 95  100)
            rc = FTW_JPG_SaveImage(hDib, strPF & Chr(0), 35)
            If Not rc = F_OK Then
                MsgBox "Problme pendant la sauvegarde du jpeg!"
                Exit Function
            End If
                
        Case "bmp"
                
            rc = FTW_BMP_SaveImage(hDib, strPF & Chr(0))
            If Not rc = F_OK Then
                MsgBox "Problme pendant la sauvegarde du bmp!"
                Exit Function
            End If
                    
        Case Else
            
            MsgBox "Extention de fichier inconnue!"
            Exit Function
                
    End Select
    
    
    
    Save = True
End Function
Private Sub ficsaveas_Click()
    Dim hDib        As Long
    
    Dim frm     As frmImg
    
    If Not GetCurrentImgWindowAndHDIB(frm, hDib) Then Exit Sub
        
    With cd
        .Filter = "Image Bitmap (*.bmp)|*.bmp|Image Jpeg (*.jpg)|*.jpg|"
        .FileName = frm.strFilePath

        .Action = 2
        If .FileName = "" Then Exit Sub
        
        frm.strFilePath = .FileName
        frm.strPlus = ""
        Save frm.strFilePath, hDib
        frm.MajCaption
    End With
End Sub

Private Sub hlp_Click()
    MsgBox "FAYA Solutions / FAYAcq.dll / exemple d'exploitation" & vbCrLf & _
            "Auteur: Mathieu YARD" & vbCrLf & _
            "Plus d'infos: http://www.fayas.com"
End Sub


Private Sub MDIForm_Load()
    CheckNoWindows
    FTW_Init Me.hWnd, F_TRACE_MAX
End Sub

Private Function Open_Init() As Boolean
    If 0 = FTW_Open() Then
        MsgBox "Impossible d'ouvrir la source de donne"
        Exit Function
    End If
    
    If 0 = FTW_Acq_Init() Then
        MsgBox "Impossible d'initier le transfert"
        FTW_Close
        Exit Function
    End If
    Open_Init = True
End Function
Private Function acquire(Optional bShowUI As Boolean = False) As Boolean

    If 0 = FTW_Acq_Go(bShowUI) Then
        MsgBox "Impossible d'initier le dbut du transfert"
        FTW_Close
        Exit Function
    End If
    
    Dim bCancel As Long
    Dim frm     As frmImg
                
    Do
        DoEvents
    Loop While FTW_MustWait(bCancel)
                
    If bCancel Then
        MsgBox "Acquisition annule"
        FTW_Close
        Exit Function
    End If
                
    Dim hDib    As Long
    Dim cnt     As Long
                
    Do While FTW_Acq_GetImage(hDib, cnt)
        Set frm = New frmImg
        frm.GoAcq hDib
        DoEvents
        If cnt = 0 Then Exit Do
    Loop
    
    FTW_Close
    
    acquire = True
End Function

Private Sub acq1b300d_Click()
    If Not Open_Init() Then Exit Sub
    If (acqmulti.Checked) Then FTW_Acq_AutoFeed
    FTW_Acq_Resolution 300, 300
    FTW_Acq_ImageType TW_PIXELTYPES.TWPT_BW, 1
    acquire
End Sub

Private Sub acq1b75d_Click()
    If Not Open_Init() Then Exit Sub
    If (acqmulti.Checked) Then FTW_Acq_AutoFeed
    
    'FTW_Acq_Resolution 75, 75
    'FTW_Acq_ImageType TW_PIXELTYPES.TWPT_BW, 1
        
    ' Une autre manire de changer tout cela:
    FTW_SetMisc TW_CAP.ICAP_XRESOLUTION, 75, 0
    FTW_SetMisc TW_CAP.ICAP_YRESOLUTION, 75, 0
    
    FTW_SetMisc TW_CAP.ICAP_PIXELTYPE, TW_PIXELTYPES.TWPT_BW, 0
    FTW_SetMisc TW_CAP.ICAP_BITDEPTH, 1, 0
    
    acquire
End Sub

Private Sub acq24b300d_Click()
    If Not Open_Init() Then Exit Sub
    If (acqmulti.Checked) Then FTW_Acq_AutoFeed
    FTW_Acq_Resolution 300, 300
    FTW_Acq_ImageType TW_PIXELTYPES.TWPT_RGB, 24
    acquire
End Sub

Private Sub acq24b75d_Click()
    If Not Open_Init() Then Exit Sub
    If (acqmulti.Checked) Then FTW_Acq_AutoFeed
    FTW_Acq_Resolution 75, 75
    FTW_Acq_ImageType TW_PIXELTYPES.TWPT_RGB, 24
    acquire
End Sub

Private Sub acq8b300d_Click()
    If Not Open_Init() Then Exit Sub
    If (acqmulti.Checked) Then FTW_Acq_AutoFeed
    FTW_Acq_Resolution 300, 300
    FTW_Acq_ImageType TW_PIXELTYPES.TWPT_GRAY, 8
    acquire
End Sub

Private Sub acq8b75d_Click()
    If Not Open_Init() Then Exit Sub
    If (acqmulti.Checked) Then FTW_Acq_AutoFeed
    FTW_Acq_Resolution 75, 75
    FTW_Acq_ImageType TW_PIXELTYPES.TWPT_GRAY, 8
    acquire
End Sub
Private Sub acqGo_Click()
    If Not Open_Init() Then Exit Sub
    If (acqmulti.Checked) Then FTW_Acq_AutoFeed
    acquire True
End Sub
Public Function NewName() As String
    Static nr As Long
    nr = nr + 1
    NewName = "image" & nr
End Function


Private Sub acqmulti_Click()
    acqmulti.Checked = IIf(acqmulti.Checked, 0, vbChecked)
End Sub

Private Sub acqSelect_Click()
    
    Select Case FTW_SelectDS()
        Case F_ERR_NULL
            Exit Sub
        Case F_ERR_USER_CANCELED
            MsgBox "L'utilisateur a annul!"
        Case F_ERR_TWAIN_RCERROR
            MsgBox "Une erreur twain est survenue!"
        Case Else
            MsgBox "Erreur inatendue!"
    End Select

End Sub

Private Sub ficquit_Click()
    Unload Me
End Sub


